/*
**	ModemPanel.c
**
**	Editing panel for modem configuration
**
**	Copyright  1990-1995 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_LIMIT_MACRO=1000,GAD_DIAL_PREFIX,GAD_DIAL_SUFFIX,
		GAD_DIAL_MODE,GAD_USE,GAD_CANCEL,GAD_DEFAULT,
		GAD_PAGER,GAD_PAGEGROUP,GAD_INTER_DIAL_DELAY,
		GAD_PBX_PREFIX,GAD_PBX
	};

STATIC UBYTE * __saveds
ShowDialRetries(struct Gadget *SomeGadget,WORD Level)
{
	if(Level < 0)
		return(LocaleString(MSG_DIAL_RETRIES_UNLIMITED_TXT));
	else
	{
		STATIC UBYTE __far Buffer[10];

		SPrintf(Buffer,"%ld",Level);

		return(Buffer);
	}
}

STATIC UBYTE * __saveds
ShowHours(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE __far Buffer[15];

	SPrintf(Buffer,LocaleString(MSG_GLOBAL_SHOW_HOURS_TXT),Level / 60,Level % 60);

	return(Buffer);
}

STATIC UBYTE * __saveds
ShowSeconds(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE __far Buffer[15];

	SPrintf(Buffer,LocaleString(MSG_GLOBAL_SHOW_MINUTES_TXT),Level / 60,Level % 60);

	return(Buffer);
}

BYTE __regargs
ModemPanel(struct Configuration *LocalConfig,BYTE *Default)
{
	STATIC LONG PageTitleID[7] =
	{
		MSG_V36_0110,
		MSG_V36_0111,
		MSG_DIALCOMMANDS_TXT,
		MSG_V36_0112,
		MSG_V36_0116,
		MSG_V36_0118,
		-1
	};

	STATIC BYTE InitialPage = 0;

	struct LayoutHandle	*Handle;
	BYTE			 Cancel = FALSE;

	SaveConfig(LocalConfig,PrivateConfig);

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
		LH_ExitFlush,	FALSE,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	TAB_KIND,
					LA_ID,		GAD_PAGER,
					LA_LabelID,	MSG_XFER_PAGE_TXT,
					LACY_LabelTable,PageTitleID,
					LACY_AutoPageID,GAD_PAGEGROUP,
					LACY_TabKey,	TRUE,
					LA_BYTE,	&InitialPage,
					LATB_FullWidth,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_ID,		GAD_PAGEGROUP,
				LAGR_ActivePage,InitialPage,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_MODEM_INIT_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> ModemInit,
						LA_Chars,	20,
						GTST_MaxChars,	79,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_MODEM_EXIT_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> ModemExit,
						GTST_MaxChars,	79,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_MODEM_HANGUP_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> ModemHangup,
						GTST_MaxChars,	79,
					TAG_DONE);

					if(LocalConfig == Config)
					{
						LT_New(Handle,
							LA_Type,	CHECKBOX_KIND,
							LA_LabelID,	MSG_DO_NOT_SEND_MODEM_COMMANDS_TXT,
							LA_BYTE,	&LocalConfig -> ModemConfig -> DoNotSendMainModemCommands,
							LA_ExtraSpace,	TRUE,
						TAG_DONE);
					}

					LT_New(Handle,
						LA_Type,	XBAR_KIND,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		INTEGER_KIND,
						LA_LabelID,		MSG_COMMAND_SEND_DELAY_TXT,
						LA_LONG,		&LocalConfig -> ModemConfig -> CharSendDelay,
						LAIN_Min,		0,
						LAIN_UseIncrementers,	TRUE,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_NO_CARRIER_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> NoCarrier,
						LA_Chars,	20,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_NO_DIALTONE_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> NoDialTone,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_CONNECT_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> Connect,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_VOICE_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> Voice,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_RING_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> Ring,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_BUSY_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> Busy,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_OK_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> Ok,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_ERROR_STRING_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> Error,
						GTST_MaxChars,	15,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					BOOL NotFound = TRUE;
					WORD i;

					for(i = 0 ; NotFound && i < strlen(LocalConfig -> ModemConfig -> DialPrefix) - 1 ; i++)
					{
						if(LocalConfig -> ModemConfig -> DialPrefix[i] == '\\' && ToUpper(LocalConfig -> ModemConfig -> DialPrefix[i + 1]) == 'W')
							NotFound = FALSE;
					}

					for(i = 0 ; NotFound && i < strlen(LocalConfig -> ModemConfig -> DialSuffix) - 1 ; i++)
					{
						if(LocalConfig -> ModemConfig -> DialSuffix[i] == '\\' && ToUpper(LocalConfig -> ModemConfig -> DialSuffix[i + 1]) == 'W')
							NotFound = FALSE;
					}

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_DIAL_PREFIX_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> DialPrefix,
						LA_Chars,	20,
						LA_ID,		GAD_DIAL_PREFIX,
						GTST_MaxChars,	79,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_MODEMPANEL_DIAL_SUFFIX_GAD,
						LA_STRPTR,	LocalConfig -> ModemConfig -> DialSuffix,
						LA_ID,		GAD_DIAL_SUFFIX,
						GTST_MaxChars,	79,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_LabelID,	MSG_DIALMODE2_GAD,
						LA_BYTE,	&LocalConfig -> ModemConfig -> DialMode,
						LA_ID,		GAD_DIAL_MODE,
						LACY_FirstLabel,MSG_DIALMODE1_TXT,
						LACY_LastLabel,	MSG_DIALMODE2_TXT,
						GA_Disabled,	NotFound,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_PBX_DIAL_PREFIX_TXT,
						LA_STRPTR,	LocalConfig -> ModemConfig -> PBX_Prefix,
						LA_ID,		GAD_PBX_PREFIX,
						GTST_MaxChars,	79,
						LA_ExtraSpace,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	CHECKBOX_KIND,
						LA_LabelID,	MSG_PBX_DIAL_MODE_TXT,
						LA_BYTE,	&LocalConfig -> ModemConfig -> PBX_Mode,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_MODEMPANEL_REDIAL_DELAY_GAD,
						LA_LONG,		&LocalConfig -> ModemConfig -> RedialDelay,
						GTSL_Min,		0,
						GTSL_Max,		60 * 60,
						GTSL_DispFunc,		ShowSeconds,
						GTSL_LevelFormat,	"%s",
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_MODEMPANEL_DIAL_RETRIES_GAD,
						LA_LONG,		&LocalConfig -> ModemConfig -> DialRetries,
						GTSL_DispFunc,		ShowDialRetries,
						GTSL_Min,		-1,
						GTSL_Max,		1000,
						GTSL_LevelFormat,	"%s",
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_MODEMPANEL_DIAL_TIMEOUT_GAD,
						LA_LONG,		&LocalConfig -> ModemConfig -> DialTimeout,
						GTSL_Min,		0,
						GTSL_Max,		1800,
						GTSL_DispFunc,		ShowSeconds,
						GTSL_LevelFormat,	"%s",
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_INTER_DIAL_DELAY_TXT,
						LA_LONG,		&LocalConfig -> ModemConfig -> InterDialDelay,
						GTSL_Min,		0,
						GTSL_Max,		1800,
						GTSL_DispFunc,		ShowSeconds,
						GTSL_LevelFormat,	"%s",
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		CHECKBOX_KIND,
						LA_LabelID,		MSG_VERBOSE_DIALING_TXT,
						LA_BYTE,		&LocalConfig -> ModemConfig -> VerboseDialing,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		CHECKBOX_KIND,
						LA_LabelID,		MSG_MODEMPANEL_NOCARRIER_IS_BUSY_GAD,
						LA_BYTE,		&LocalConfig -> ModemConfig -> NoCarrierIsBusy,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		XBAR_KIND,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		CHECKBOX_KIND,
						LA_LabelID,		MSG_MODEMPANEL_CONNECT_AUTO_BAUD_GAD,
						LA_BYTE,		&LocalConfig -> ModemConfig -> ConnectAutoBaud,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		CHECKBOX_KIND,
						LA_LabelID,		MSG_MODEMPANEL_ABORT_HANGS_UP_TXT,
						LA_BYTE,		&LocalConfig -> ModemConfig -> AbortHangsUp,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_MODEMPANEL_TIME_TO_CONNECT_GAD,
						LA_LONG,		&LocalConfig -> ModemConfig -> TimeToConnect,
						LA_Chars,		8,
						GTSL_Min,		0,
						GTSL_Max,		60 * 60,
						GTSL_DispFunc,		ShowSeconds,
						GTSL_LevelFormat,	"%s",
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,		CHECKBOX_KIND,
						LA_LabelID,		MSG_MODEMPANEL_DROP_DTR_ON_HANGUP_GAD,
						LA_BYTE,		&LocalConfig -> ModemConfig -> DropDTR,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		CHECKBOX_KIND,
						LA_LabelID,		MSG_MODEMPANEL_REDIAL_AFTER_HANGUP_GAD,
						LA_BYTE,		&LocalConfig -> ModemConfig -> RedialAfterHangup,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,		SliderType,
						LA_LabelID,		MSG_MODEMPANEL_CONNECTION_LIMIT_GAD,
						LA_WORD,		&LocalConfig -> ModemConfig -> ConnectLimit,
						GTSL_Min,		0,
						GTSL_Max,		1440,
						GTSL_DispFunc,		ShowHours,
						GTSL_LevelFormat,	"%s",
					TAG_DONE);

					LT_New(Handle,
						LA_Type,		STRING_KIND,
						LA_LabelID,		MSG_MODEMPANEL_LIMIT_MACRO_GAD,
						LA_STRPTR,		LocalConfig -> ModemConfig -> ConnectLimitMacro,
						LA_Chars,		20,
						LA_ID,			GAD_LIMIT_MACRO,
						GTST_MaxChars,		MAX_FILENAME_LENGTH - 1,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,LA_Type,XBAR_KIND,LAXB_FullSize,TRUE,TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Build(Handle,
			LAWN_TitleID,		MSG_MODEMPANEL_MODEM_PREFERENCES_TXT,
			LAWN_IDCMP,		IDCMP_CLOSEWINDOW,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
			WA_SimpleRefresh,	TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass;
			struct Gadget		*MsgGadget;
			WORD			 i;
			BOOL			 NotFound;

			GuideContext(CONTEXT_MODEM);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,LocalConfig);

					break;
				}

				while(Message = (struct IntuiMessage *)LT_GetIMsg(Handle))
				{
					MsgClass	= Message -> Class;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					LT_ReplyIMsg(Message);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,LocalConfig);

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_DIAL_PREFIX:
							case GAD_DIAL_SUFFIX:
							case GAD_DIAL_MODE:

								for(i = 0, NotFound = TRUE ; NotFound && i < strlen(LocalConfig -> ModemConfig -> DialPrefix) - 1 ; i++)
								{
									if(LocalConfig -> ModemConfig -> DialPrefix[i] == '\\' && ToUpper(LocalConfig -> ModemConfig -> DialPrefix[i + 1]) == 'W')
										NotFound = FALSE;
								}

								for(i = 0 ; NotFound && i < strlen(LocalConfig -> ModemConfig -> DialSuffix) - 1 ; i++)
								{
									if(LocalConfig -> ModemConfig -> DialSuffix[i] == '\\' && ToUpper(LocalConfig -> ModemConfig -> DialSuffix[i + 1]) == 'W')
										NotFound = FALSE;
								}

								LT_SetAttributes(Handle,GAD_DIAL_MODE,
									GA_Disabled,NotFound,
								TAG_DONE);

								break;

							case GAD_USE:

								LT_UpdateStrings(Handle);

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,LocalConfig);

								Cancel = Done = TRUE;
								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;
								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	if(!Cancel && LocalConfig -> MiscConfig && LocalConfig -> SerialConfig)
	{
		if(LocalConfig -> MiscConfig -> ProtectiveMode && LocalConfig -> SerialConfig -> BaudRate >= 4800 && LocalConfig -> ModemConfig -> ConnectAutoBaud)
		{
			if(MyEasyRequest(Window,LocaleString(MSG_AUTOBAUD_TXT),LocaleString(MSG_GLOBAL_YES_NO_TXT)))
				LocalConfig -> ModemConfig -> ConnectAutoBaud = FALSE;
		}
	}

	if(Default)
		return((BYTE)(!Cancel));
	else
		return((BYTE)memcmp(PrivateConfig -> ModemConfig,LocalConfig -> ModemConfig,sizeof(struct ModemSettings)));
}
